% Final Problem 3
% Coded by NFR on 5.4.2019                % 3 pt for header (free points!)
%
close all
clc
D = xlsread('data.xlsx');                                                   % 2 pts - Read data
% We have volume vs. time for the pumps, we need to determine FLOW RATE.
% Fit this data and find slope.
Rsqrvec = zeros(50,1);
FRvec = zeros(50,1);
tvec = (0:50)';
for i = 1:50
    [m,gof] = fit(tvec,D(:,i),'poly1');                 % 3 pt - correct use of a linear fit and reporting of slope and gof
    FRvec(i,1) = m.p1;                                  % 2 pt - setting up correct loop format to find and store these
    Rsqrvec(i,1) = gof.rsquare;
end
% Part (a)
% Let's investigate the coefficient of determination for each of the fits
PN = (1:50);                      
plot(PN,Rsqrvec,'o')                                  % 3 pt - identifying trial 15 as change of sensor moment AND valid method of backing up this observation
xlabel('Pump Trial Number')
ylabel('R squared value of fit')
disp('From r-squared data it is clear the sensor was changed at trial 15')
%
% Part (b) Univariate stats on the flow rates
disp('Average flow rate(L/min):')                  % 2 pt - solving and displaying flow rate
AvgFlow = mean(FRvec)                              %
disp('95% confidence interval is +/- (L/min):')   
cinterval = 2*std(FRvec)                            % 2 pt - solving and displaying conf interval
% Part (c) Histogram
histogram(FRvec)                                    % 3 pt - histogram with labels
xlabel('Flow Rate (L/s)')
ylabel('Frequency')


